#!/usr/bin/perl
#
#    Cluster Systems Management Webmin Module
#    Copyright (C) 2002 by IBM Corp.
#
# Configure CFM

use strict;
use lib $ENV{PWD};
require GuiUtils;
GuiUtils->init();
GuiUtils->addHeader(undef, 4);



my @files = &getFilelist("/cfmroot");
my $sample_files = "<li>" . join "<br><li>", @files;

my $cron = `/usr/bin/crontab -l | grep cfmupdatenode`;

my $code = GuiUtils->processHTML('cfm-src.html');
eval $code;
if (length($@)) { print "<P>$@</P>"; }

&footer('', 'CSM Home');


sub getFilelist{
    my $dir = $_[0];
    my $file;
    my @samples;
    my @subdirs = ();
    opendir(DIRECTORY, $dir) or print "Cannot open directory $dir";
    while ($file = readdir(DIRECTORY)){
	#Make sure its not the . or ..
	if ($file ne '.' and $file ne '..'){
	    my $filename = "$dir/$file";
   	   
	    if( -d $filename){
		push @subdirs, $filename;
	    }
	    elsif($filename =~ m/EmptyGroup/){
		my $where = readlink("$filename");
		if($where){
			$filename .= " -> $where";
		}
		push @samples, $filename;
	    }
	}
    }
    
    closedir(DIRECTORY);
    foreach my $sub (@subdirs){
	my @tmp_files = &getFilelist($sub);
	push @samples, @tmp_files;
    }
    
    return @samples;
}

