#!/usr/bin/perl
#
#    Cluster Systems Management Webmin Module
#    Copyright (C) 2002 by IBM Corp.
#
# Display properties for csmconfig

use strict;
BEGIN { $::CSMDIR = '..'; }
use lib "$::CSMDIR";
require GuiUtils;
GuiUtils->init();
#%access=&get_module_acl;

GuiUtils->addHeader('csmconfig', 7);

#my ($name, $nodeNames, $managementScope, $resourceClass, $selectionString, $eventExpression, $rearmExpression, $monitorStatus, $eventOccurred, $severity, $immediateEvaluate);
my %values;
my $changedAttrStr;

if (exists($::in{changeButton}))           # changing properties
  {
		# Get original values
		my %orig = split(/:\|:/, $::in{origValues});
		#print "<p>orig=", join(',',%orig), "</p>\n";

		my %changedAttrs;
		foreach my $k (keys %::in)
		  {
			my $a;
			if ((($a)=$k=~/^input(.+)$/) && ($::in{$k} ne $orig{$a}))       # if it is an input field and different from the original value
			  {
				my $v = $::in{$k};
				$v =~ s/\s*\(.*$//;     # skip the stuff in parens, which is just explanation
				#if ($a eq 'NodeNames' && $v!~/^\{.*\}$/) { $v = "{$v}"; }
				$changedAttrs{$a} = NodeUtils->quote($v);
			  }
		  }
		if (scalar(%changedAttrs))
		  {
			#if (exists($changedAttrs{NodeNames}) && $changedAttrs{NodeNames}!~/^\{.*\}$/) { $changedAttrs{NodeNames} = '{' . $changedAttrs{NodeNames} . '}'; }
			my $attrStr = '';
			foreach my $k (keys %changedAttrs) { $attrStr .= " $k=$changedAttrs{$k}"; }
			my $outref = GuiUtils->runcmd(qq(/opt/csm/bin/csmconfig $attrStr));
			if (!$::RUNCMD_RC)
			  {
				$changedAttrStr = 'Properties changed: ' . join(', ', keys %changedAttrs);
			  }
		  }
		else { $changedAttrStr = 'No properties were changed.'; }
  }

# Whether we are 1st coming to this page or have changed params, display it
#my $cmd = qq(lsrsrc-api -D ':|:' -i -n -s IBM.Condition::"Name IN ('$condition')"::Name::NodeNames::ManagementScope::ResourceClass::SelectionString::EventExpression::RearmExpression::MonitorStatus::EventOccurred::Severity::ImmediateEvaluate);
my $outref = GuiUtils->runcmd('/opt/csm/bin/csmconfig');
	
#%values = split(/:\|:/, $$outref[0]);      # this puts the pairs of attr name and value in the hash correctly
foreach my $l (@$outref)
  {
	my ($a, $v) = $l=~/^\s*(\S+)\s*=\s*(.*)$/;
	$values{$a} = $v;
  }

my $code = GuiUtils->processHTML('index-src.html');
eval $code;
if (length($@)) { print "<P>$@</P>"; }

&footer('', 'CSM Home');

