#!/usr/bin/perl
#
#    Cluster Systems Management Webmin Module
#    Copyright (C) 2002 by IBM Corp.
#
# Gather dcp options and then run the command

use strict;
#use CGI::Cookie;
BEGIN { $::CSMDIR = '.'; }
use lib "$::CSMDIR";
require GuiUtils;
GuiUtils->init();

my $DCP_CMD = ((-x "$GuiUtils::csmroot/bin/dcp")?"$GuiUtils::csmroot/bin/dcp":undef) || ((-x "$GuiUtils::csmroot/ect/bin/dcp")?"$GuiUtils::csmroot/ect/bin/dcp":undef);

GuiUtils->addHeader(undef, 0, 'Copy Files');

if (exists($::in{copyButton}))    # copy the files and show the cmd output
  {
	print "<H2>Copy Command Output:</H2>\n";
	my $cmd = $DCP_CMD;
	if ($::in{fanoutField}=~/\S/) { $cmd .= " -f $::in{fanoutField}"; }
	if ($::in{useridField}=~/\S/) { $cmd .= " -l $::in{useridField}"; }
	if (exists($::in{recursiveCheckbox})) { $cmd .= ' -r'; }
	if (exists($::in{verboseCheckbox})) { $cmd .= ' -v'; }
	#todo: add the remote copy cmd and options, when they are added to dcp
	$cmd .= " -n $::in{nodes}";
	if (exists($::in{pullCheckbox})) { $cmd .= " -p $::in{targetField} $::in{filesField}"; }  # switch from file and target
	else { $cmd .= " $::in{filesField} $::in{targetField}"; }
	GuiUtils->runcmd($cmd, 1);
	#GuiUtils->runcmd("scp $::in{filesField} $::in{nodes}:$::in{targetField}", 1);
	print "<P><BR></P>\n";
	&footer("dcp.cgi?nodes=$::in{nodes}", 'Copy Files');
  }
else     # no action yet, just displaying the form
  {
	my $nodcp = !$DCP_CMD;
	my $code = GuiUtils->processHTML('dcp-src.html');
	eval $code;
	if (length($@)) { print "<P>$@</P>"; }
	&footer('', 'CSM Home');
  }
