#!/usr/bin/perl
#
#    Cluster Systems Management Webmin Module
#    Copyright (C) 2002 by IBM Corp.
#
# Get input for definenode

use strict;
use lib $ENV{PWD};
require GuiUtils;
GuiUtils->init();

#%access=&get_module_acl;

GuiUtils->addHeader(undef, 1);

my %values;

# If they pushed the Define Node button, run definenode
if (exists($::in{defineButton}) || exists($::in{createNodedefButton}))       # they pushed the Define from Values or Create Nodedef button
  {
	my $isCreate = exists($::in{createNodedefButton});
	if ($isCreate) { delete $::in{createNodedefButton}; }
	else { delete $::in{'defineButton'}; }

	# Copy the attr values into the values hash so they will be filled into
	# the text fields
	%values = %::in;

	my $cmd = "$GuiUtils::csmroot/bin/definenode";
	$cmd .= " -n $::in{Hostname}";
	delete $::in{Hostname};
	if (exists($::in{Count}))
	  {
		if ($::in{Count} =~ /\S/) { $cmd .= " -c $::in{Count}"; }
		delete $::in{Count};
	  }
	if ($::in{HWControlPoint}=~/[:,]/)
	  {
		$cmd .= ' -H ' . NodeUtils->quote($::in{HWControlPoint});
		delete $::in{HWControlPoint};
	  }
	if ($::in{ConsoleServerName}=~/[:,]/)
	  {
		$cmd .= ' -C ' . NodeUtils->quote($::in{ConsoleServerName});
		delete $::in{ConsoleServerName};
	  }

	if ($isCreate) { $cmd .= ' -s'; }
	
	foreach my $key (keys %::in){ #the leftovers are all attributes
	  if($::in{$key} =~ m/\S/ && $key ne 'nodedefField'){ #if it matches a non-whitespace character
		$cmd .= " $key=" . NodeUtils->quote($::in{$key});
	  }
	}

	if ($isCreate) { $cmd .= ' > ' . NodeUtils->quote($::in{nodedefField}); }
	
	GuiUtils->runcmd($cmd, 1);
	if ($::RUNCMD_RC)          # the error msg is in the nodedef file
	  {
		my @output = NodeUtils->readFile($::in{nodedefField});
		foreach (@output) { print "$_<BR>\n"; }
	  }
  }
if (exists($::in{nodedefButton}))       # they pushed the Define from Nodedef button
  {
	$values{nodedefField} = $::in{nodedefField};
	my $cmd = "$GuiUtils::csmroot/bin/definenode";
	$cmd .= ' -f ' . NodeUtils->quote($::in{nodedefField});
	GuiUtils->runcmd($cmd, 1);
  }
else
  {
	#todo: this only works if the mgmt svr is not also defined as a node
	# Get default values for definenode
	#my $hostname = (`hostname`)[0];
	#my $output = GuiUtils->runcmd("$GuiUtils::csmroot/bin/definenode -s -n $hostname");
	#foreach my $line (@$output){
	#  if($line =~ m/=/){
	#	$line =~ s/\s//;#remove all whitespace from the line
	#	my ($attr, $value) = split "=", $line;
	#	$values{$attr}=$value;
	#  }
	#}
  }

my $code = GuiUtils->processHTML('definenode-src.html');
eval $code;
if (length($@)) { print "<P>$@</P>"; }

&footer('', 'CSM Home');


