#!/usr/bin/perl
#
#    Cluster Systems Management Webmin Module
#    Copyright (C) 2002 by IBM Corp.
#
# Run the diagnose cmds on the mgmt svr

use strict;
BEGIN { $::CSMDIR = '..'; }
use lib "$::CSMDIR";
require GuiUtils;
GuiUtils->init();

GuiUtils->addHeader('diagms', 6, 'Run Diag Cmds', 1);

print "<H2>Diagnostic Commands and Output:</H2>\n";

$::GUI_VERBOSE = 1;      # always want to show them the cmds we are running on this page
if (exists($::in{probeButton}))     # run probemgr
  {
	GuiUtils->msg('I', 'Probing.  This may take a while...');
	#GuiUtils->runcmd('/opt/diagnostics/bin/probemgr', 1, {NoVerbose=>1});
	my $out = GuiUtils->runcmd('/opt/diagnostics/bin/probemgr -l 0', 3, {NoVerbose=>1});
	GuiUtils->processProbeOutput($out);
	
	#GuiUtils->runcmd('/home/bp/bin/slowoutput', 1, {NoVerbose=>1});
	#for (my $i=1; $i<=5; $i++) { print "<p>$i</p>\n";  sleep 5; }
  }
elsif (exists($::in{lssrcButton}))     # run lssrc
  {
	GuiUtils->runcmd('lssrc -a', 1, {NoVerbose=>1});
  }
elsif (exists($::in{stopsrcButton}))     # restart rmc
  {
	GuiUtils->runcmd('/usr/sbin/rsct/bin/rmcctrl -z; /usr/sbin/rsct/bin/rmcctrl -s', 1, {NoVerbose=>1});
  }
elsif (exists($::in{dmsrmTraceButton}))     # display the dmsrm trace file
  {
	GuiUtils->runcmd('/usr/sbin/rsct/bin/rpttr /var/ct/IW/log/mc/IBM.DMSRM/trace | tail -n 2000', 1, {NoVerbose=>1});
  }
elsif (exists($::in{hwctrlrmTraceButton}))     # display the hwctrlrm trace file
  {
	GuiUtils->runcmd('/usr/sbin/rsct/bin/rpttr /var/ct/IW/log/mc/IBM.HWCTRLRM/trace | tail -n 2000', 1, {NoVerbose=>1});
  }
elsif (exists($::in{errmTraceButton}))     # display the errm trace file
  {
	GuiUtils->runcmd('/usr/sbin/rsct/bin/rpttr -o dtic /var/ct/IW/log/mc/IBM.ERRM/trace | tail -n 2000', 1, {NoVerbose=>1});
  }

print "<P><BR></P>\n";
&footer('.', 'Diagnose MS');
