#!/usr/bin/perl
#
#    Cluster Systems Management Webmin Module
#    Copyright (C) 2002 by IBM Corp.
#
# Run the dsh cmd and display the output

use strict;
use lib $ENV{PWD};
require GuiUtils;
GuiUtils->init();

my $DCP_CMD = ((-x "$GuiUtils::csmroot/bin/dcp")?"$GuiUtils::csmroot/bin/dcp":undef) || ((-x "$GuiUtils::csmroot/ect/bin/dcp")?"$GuiUtils::csmroot/ect/bin/dcp":undef);

#%access=&get_module_acl;

## put in ACL checks here if needed


#GuiUtils->addHeader_cookie('dsh', 0, 'Run Cmd');


my $dsh_page = "dsh.cgi?nodes=$::in{nodes}";
my $dsh_string;
my $dsh_command = "$GuiUtils::csmroot/bin/dsh ";
my $dsh_options;
my $dcpcmd;
if($::in{history}){ #this is a command from the history
    $dsh_command .= "-n $::in{nodes} ";
    $dsh_string = NodeUtils->quote($::in{history});
}
else{
    if($::in{verify}){ $dsh_options .= "-v "; }
    if($::in{streaming_mode}){ $dsh_options .= "-s "; }
    if($::in{monitor}){ $dsh_options .= "-m "; }
    if($::in{return_code}){ $dsh_options .= "-z "; }
    if($::in{keep_sending}){ $dsh_options .= "-c "; }
    if($::in{fanout}){ $dsh_options .= "-f $::in{fanout} "; }
    if($::in{userid}){ $dsh_options .= "-l $::in{userid} "; }
    if($::in{remote_shell}){ $dsh_options .= "-r $::in{remote_shell} "; }
    if($::in{shell_options}){ 
	if($::in{shell_options} =~ m/\".*\"/){ #already had quotes
	    $dsh_options .= "-o $::in{shell_options} ";
	}
	else{
	    $dsh_options .= qq(-o "$::in{shell_options} " ); 
	}
    }
    $dsh_command .= "-n $::in{nodes} ";

	# Handle the actual user command now
	if (exists($::in{copyCheckbox}))
	  {
		my ($executable, $options) = split(/\s/, $::in{command});
		my ($dirname, $basename) = $executable =~ m|^(.*)/([^/]+)$|;
		$dcpcmd = "$DCP_CMD ";
		if ($::in{fanout}) { $dcpcmd .= "-f $::in{fanout} "; }
		$dcpcmd .= "-n $::in{nodes} ";
		$dcpcmd .= "$executable /tmp/$basename";

		$dsh_string .= "/tmp/$basename " . NodeUtils->quote($options);
	  }
	else { $dsh_string .= NodeUtils->quote($::in{command}); }
}

$dsh_command .= $dsh_options . $dsh_string;

GuiUtils->addHeader('dsh', 0, 'Run Cmd', 1);
my $code = GuiUtils->processHTML('exec_dsh-src.html');
eval $code;

#print "<h2>Running Command:</h2> $dsh_command";
#print "<H2>Command Output:</H2>\n";
$::RUNCMD_RC = 0;
if ($dcpcmd) { GuiUtils->runcmd($dcpcmd, 1); }
if (!$::RUNCMD_RC) { GuiUtils->runcmd($dsh_command, 1, { NoVerbose => 1 }); }
print "<P><BR></P>\n";

&footer($dsh_page, 'Run Cmd');




