#!/usr/bin/perl
# IBM_PROLOG_BEGIN_TAG 
# This is an automatically generated prolog. 
#  
#  
#  
# Licensed Materials - Property of IBM 
#  
# (C) COPYRIGHT International Business Machines Corp. 2003,2004 
# All Rights Reserved 
#  
# US Government Users Restricted Rights - Use, duplication or 
# disclosure restricted by GSA ADP Schedule Contract with IBM Corp. 
#  
# IBM_PROLOG_END_TAG 
#
#    Cluster Systems Management Webmin Module
#    Copyright (C) 2002 by IBM Corp.
#
# Do HW Ctrl on the nodes

use strict;
BEGIN { $::CSMDIR = '..'; }
use lib "$::CSMDIR";
require GuiUtils;
GuiUtils->init();


GuiUtils->addHeader('hwctrl', 0, 'HW Ctrl => Get/Save NodeIds');


my %values = ();
my %orig = ();
my $mixed = "(mixed values)";


GuiUtils->splitInputValues(\%values, \%orig);

my $nodes = $values{nodes};
my @node_array = split(/,/, $nodes);

if (exists($orig{HWControlPoint})) {
	$values{HWControlPoint} = $orig{HWControlPoint};
}

if (exists($orig{PowerMethod})) {
	$values{PowerMethod} = $orig{PowerMethod};
}


if (exists($orig{numNodes})) {
	$values{numNodes} = $orig{numNodes};
	for my $i (0 .. $values{numNodes}) {
		my $nodeid = "nodeid$i";
		$values{$nodeid} = $orig{$nodeid};
	}
} else {

	my %hohInfo = ();
	my ($rc, $hwInfo) = GuiUtils->getHcpHwInfo(\%values, \@node_array);

	#foreach my $nd (@$hwInfo) {
	#	print(qq(<p>Node: $nd</p>));
	#}


	GuiUtils->parseHCPHwInfo($hwInfo, \@node_array, \%hohInfo);


	my $i = 0;
	foreach my $host (sort keys %{$hohInfo{HWControlNodeId}}) {
		if ($hohInfo{HWControlNodeId}{$host} ne $values{HWControlPoint}) {
			#print(qq(<p>HWControlNodeId: "$hohInfo{HWControlNodeId}{$host}", "$values{HWControlPoint}" </p>));
			my $hostname = "hostname$i";
			my $nodeid = "nodeid$i";
			if (!exists($values{$hostname})) {
				$values{$hostname} = $host;
				$values{$hostname} =~ s/^\d+_//;
			}
			if (!exists($values{$nodeid})) {
				$values{$nodeid} = $hohInfo{HWControlNodeId}{$host};
			}
			$i += 1;

		}
	}

	if (!exists($values{numNodes})) {
		$values{numNodes} = $i - 1;
	}
}

setNodes();

# Reset the node array
@node_array = split(/,/, $nodes);

if (exists($values{setnametoidButton})) { 
	for my $i (0 .. $values{numNodes}) {
		my $hostname = "hostname$i";
		my $nodeid = "nodeid$i";
		$values{$hostname} = $values{$nodeid};
	}
	delete ($values{setnametoidButton});
	setNodes();
}

if (exists($values{undoButton})) { 
	for my $i (0 .. $values{numNodes}) {
		my $hostname = "hostname$i";
		$values{$hostname} = $orig{$hostname};
	}
	delete ($values{undoButton});
	setNodes();
}

if (exists($values{saveButton})) { 
	#print("<p>$values{HWControlPoint}</p>");
	#print("<p>$nodes</p>");

	my $powerMethod = GuiUtils->parseValues("PowerMethod", 
		\%values, \@node_array);
	my $hwControlPoint = GuiUtils->parseValues("HWControlPoint", 
		\%values, \@node_array);
	for my $i (0 .. $values{numNodes}) {
		my $hostname = "hostname$i";
		my $nodeid = "nodeid$i";
		if ($values{$hostname} ne $orig{$hostname} && 
		$values{$hostname} ne "no_hostname") {
			my $nodeName = $values{$hostname};
			#print("<p>$nodeName, $hostname, $orig{$hostname}</p>");
			GuiUtils->runcmd("$GuiUtils::csmroot/bin/definenode -m -n $nodeName -H $$hwControlPoint{$nodeName} HWControlNodeId=\"$values{$nodeid}\" PowerMethod=\"$$powerMethod{$nodeName}\"");
		}
	}

	delete ($values{saveButton});

	if ($::RUNCMD_RC == 0) {
		delete ($orig{orig});
	}
}

setNodes();
#print(qq(Node: $nodes));

my $code = GuiUtils->processHTML('nodeids-src.html');
eval $code;
if (length($@)) { print "<P>$@</P>"; }

my %rh = (
	nodes => $values{nodes},
	HWControlPoint => $values{HWControlPoint},
	PowerMethod => $values{PowerMethod},
	InitPowerStatus => 1,
	);
GuiUtils->addFooter("./index.cgi", "HW Ctrl", \%rh);

sub setNodes {
	# Regenerate host name list if one not exist
	$nodes = '';
	for my $i (0 .. $values{numNodes}) {
		my $hostname = "hostname$i";
		#$values{nodes} .= ",$values{$hostname}";
		$nodes .= ",$values{$hostname}";
	}
	$nodes =~ s/^,//;
	$values{nodes} = $nodes;
}
