#!/usr/bin/perl
#
#    Cluster Systems Management Webmin Module
#    Copyright (C) 2002 by IBM Corp.
#
# Display updatenode cmd results

use strict;
BEGIN { $::CSMDIR = '..'; }
use lib "$::CSMDIR";
require GuiUtils;
GuiUtils->init();
require InstallUtils;

#%access=&get_module_acl;

GuiUtils->addHeader('copycd', 0, 'Copy CD', 1);
my $cmd = "copycds ";

if (exists($::in{Verbose})) {
	$cmd .= "-v ";
}

if (exists($::in{ChangeOrder})) {
	$cmd .= "-x ";
}

#foreach my $key (keys %::in) {
#	print qq(<p> $key: $::in{$key} </p>);
#}

if (exists($::in{SelectOSDistributionMenu})) {
	my $distro = $::in{SelectOSDistributionMenu};
	my ($installOSName, $installDistributionName, 
		$installDistributionVersion, $installPkgArchitecture) = 
		split(/\s+/, $distro);
	if ($installOSName ne "*") {
		$cmd .= "InstallOSName=$installOSName ";
	}

	if ($installDistributionName ne "*") {
		$cmd .= "InstallDistributionName=$installDistributionName ";
	}

	if ($installDistributionVersion ne "*") {
		$cmd .= "InstallDistributionVersion=$installDistributionVersion ";
	}

	if ($installPkgArchitecture ne "*") {
		$cmd .= "InstallPkgArchitecture=$installPkgArchitecture ";
	}
	
}

if (($::in{InstallServiceLevel} ne "null") && 
	!($::in{InstallServiceLevel} =~ /\s+$/)) {
	$cmd .= "InstallServiceLevel=$::in{InstallServiceLevel}";
}



print "<H2>Run copycds command </H2>\n";
print "<p>$cmd</p>\n";
print "<p>This command is not run yet!</p>\n";


print "<P><BR></P>\n";

GuiUtils->addFooter("./copydistro.cgi", "Copy CD or Change Install File Order", \%::in);


