#!/usr/bin/perl
#
#    Cluster Systems Management Webmin Module
#    Copyright (C) 2002 by IBM Corp.
#
# Display updatenode cmd results

use strict;
BEGIN { $::CSMDIR = '..'; }
use lib "$::CSMDIR";
require GuiUtils;
GuiUtils->init();
require InstallUtils;


GuiUtils->addHeader('installnodes', 0, 'Install Nodes', 1);
print "<H2>Installnode Command Output:</H2>\n";

#foreach my $input (keys %::in) {
#	print "<p>$input, $::in{$input} </p>";
#}

if (exists($::in{installNodes})) {
	delete($::in{installNodes});
	
}


my $what = qq(Hostname::InstallOSName::InstallDistributionName::InstallDistributionVersion::InstallPkgArchitecture);
my @node_array = split(/,/, $::in{nodes});

my $attrNodeHoh = GuiUtils->getNodeAttrFromCSMDB(\@node_array, $what);
my $nodeAttrHoh = GuiUtils->reverseHashHash($attrNodeHoh);

my %sys = ();
foreach my $node (keys %$nodeAttrHoh) {
	my $system = $$nodeAttrHoh{$node}{InstallOSName}
        . " " . $$nodeAttrHoh{$node}{InstallDistributionName}
        . " " . $$nodeAttrHoh{$node}{InstallDistributionVersion}
        . " " . $$nodeAttrHoh{$node}{InstallPkgArchitecture};
	if (exists($sys{$system})) {
		$sys{$system} .= ",$node";
	} else {
		$sys{$system} = "$node";
	}
}

my %cmds = ();
foreach my $type (keys %sys) {
#	print "<p>$type, $sys{$type}</p>";
	$cmds{$type} = "installnode";

	if ($::in{Verbose} == 1) {
		$cmds{$type} .= " -v";
	}

	if (!GuiUtils->isEmpty($::in{timeout})) {
		$cmds{$type} .= " -t $::in{timeout}";
	}

	$cmds{$type} .= " -n $sys{$type}";
}

foreach my $cmd (keys %cmds) {
	#print "<p> $cmd, $cmds{$cmd} </p>";
	GuiUtils->runcmd("$GuiUtils::csmroot/bin/$cmds{$cmd}", 1);
}


print "<P><BR></P>\n";

GuiUtils->addFooter("./installnode.cgi", "Install Nodes", \%::in);
