#!/usr/bin/perl
#
#    Cluster Systems Management Webmin Module
#    Copyright (C) 2002 by IBM Corp.
#
# Display updatenode cmd results

use strict;
BEGIN { $::CSMDIR = '..'; }
use lib "$::CSMDIR";
require GuiUtils;
GuiUtils->init();
require InstallUtils;


GuiUtils->addHeader('csetupinstall', 0, 'Set Up Install', 1);
print "<H2>Updatenode Command Output:</H2>\n";

#foreach my $input (keys %::in) {
#	print "<p>$input, $::in{$input} </p>";
#}

if (exists($::in{setUpNodes})) {
	delete($::in{setUpNodes});
	
}

my $what = qq(Hostname::InstallOSName::InstallDistributionName::InstallDistributionVersion::InstallPkgArchitecture);
my @node_array = split(/,/, $::in{nodes});

my $attrNodeHoh = GuiUtils->getNodeAttrFromCSMDB(\@node_array, $what);
my $nodeAttrHoh = GuiUtils->reverseHashHash($attrNodeHoh);

my %sys = ();
foreach my $node (keys %$nodeAttrHoh) {
	my $system = $$nodeAttrHoh{$node}{InstallOSName}
        . " " . $$nodeAttrHoh{$node}{InstallDistributionName}
        . " " . $$nodeAttrHoh{$node}{InstallDistributionVersion}
        . " " . $$nodeAttrHoh{$node}{InstallPkgArchitecture};
	if (exists($sys{$system})) {
		$sys{$system} .= ",$node";
	} else {
		$sys{$system} = "$node";
	}
}

my %cmds = ();
foreach my $type (keys %sys) {
#	print "<p>$type, $sys{$type}</p>";
	my $cdpath = "CDPATHNAME" . $type;
	my $cdchkbox = "CDPATHCHKNAME" . $type;
	my $pxoption;
	if ($::in{$cdchkbox} == 1) {
		$pxoption = " -x";
	} else {
		if (!GuiUtils->isEmpty($::in{$cdpath})) {
			$pxoption = " -p $::in{$cdpath}";
		}
	}

	my $conf = "CONFIGURATIONFILE" . $type;
	my $koption;
	if (!GuiUtils->isEmpty($::in{$conf})) {
		$koption = " -k $::in{$conf}";
	}

	my $noption = " -n $sys{$type}";

	my $voption;
	if ($::in{Verbose} == 1) {
		$voption = " -v";
	}

	my $gateway;
	if (!GuiUtils->isEmpty($::in{Gateway})) {
		$gateway = " Gateway=$::in{Gateway}";
	}

	my $nameservers;
	if (!GuiUtils->isEmpty($::in{Nameservers})) {
		$nameservers = " Nameservers=$::in{Nameservers}";
	}

	if ($type =~ /RedHat/) {
		$cmds{$type} = "csmsetupks";
	} elsif (($type =~ /SuSE/) || ($type =~ /SLES/)) {
		$cmds{$type} = "csmsetupyast";
	} else {
		print "<p>System $type is not supported currently. </p>";
		last;
	}
	
	$cmds{$type} .= $pxoption 
		. $koption 
		. $noption 
		. $voption 
		. $gateway 
		. $nameservers;
}

foreach my $cmd (keys %cmds) {
	#print "<p> $cmd, $cmds{$cmd} </p>";
	GuiUtils->runcmd("$GuiUtils::csmroot/bin/$cmds{$cmd}", 1);
}

print "<P><BR></P>\n";

GuiUtils->addFooter("./setup.cgi", "Set Up Install", \%::in);
