#!/usr/bin/perl
#
#    Cluster Systems Management Webmin Module
#    Copyright (C) 2002 by IBM Corp.
#
# Display and modify node groups

use strict;
use lib $ENV{PWD};
require GuiUtils;
GuiUtils->init();

$ENV{'CT_MANAGEMENT_SCOPE'}=1;
#%access=&get_module_acl;

my $isAction = exists($::in{dynTestButton});
GuiUtils->addHeader(undef, 2, $isAction?'Try Dynamic Nodegroup Select String':undef);

# Process the buttons
if (exists($::in{trySelectButton}))
  {
	print "<H3>Select String Query:  $::in{selectString}</H3>\n";
	GuiUtils->runcmd("$GuiUtils::csmroot/bin/lsnode -w " . NodeUtils->quote($::in{selectString}), 1);
	print "<P></P>\n";
	&footer("nodegrp.cgi?groupName=$::in{groupName}&groupType=$::in{groupType}&selectString=$::in{selectString}", 'CSM Node Groups');
	return;
  }
elsif (exists($::in{chgroupButton}))
  {
	my $options;
	if ($::in{groupType} eq 'staticType')
	  {
		if (exists($::in{generic})) { $options .= ' -g'; }
		$options .= ' -n ' . NodeUtils->quote($::in{memberList});
	  }
	else    # dynamic
	  {
		$options .= ' -w ' . NodeUtils->quote($::in{selectString});
	  }
	GuiUtils->runcmd("$GuiUtils::csmroot/bin/nodegrp $options $::in{groupName}");
	if ($::RUNCMD_RC == 0)
	  {
		GuiUtils->msg('I', "$::in{groupName} succesfully changed/created.");
		$::in{group} = $::in{groupName};
	  }
  }
elsif (exists($::in{delgroupButton}))
  {
	GuiUtils->runcmd("$GuiUtils::csmroot/bin/nodegrp -D $::in{groupName}");
	if ($::RUNCMD_RC == 0)
	  {
		GuiUtils->msg('I', "$::in{groupName} succesfully removed.");
	  }
  }

#my (@output, @nodes, @nodegrp, @allnodes);
#if($::in{group} && ($::in{group} ne "all")){
#	my $nodegrp_option = "$::in{group} ";
#	@output = `/opt/csm/bin/nodegrp $nodegrp_option`;
#	foreach my $line (@output){ chomp $line; push @nodes, $line; }
#}
#@output = `/opt/csm/bin/lsnode`;
#foreach my $line (@output){
#	chomp $line;
#	push @allnodes, $line;
#}

# Get list of node groups
my $nodegroups = GuiUtils->runcmd("$GuiUtils::csmroot/bin/nodegrp");
@$nodegroups = sort @$nodegroups;

# Get the attributes for the selected node group
my ($groupName, $groupType, $memberList, $selectString, $genericChecked, $staticChecked, $dynamicChecked);
if (exists($::in{group}))
  {
	my $outref = GuiUtils->runcmd("$GuiUtils::csmroot/bin/nodegrp -L $::in{group}");
	my ($contents, $genericStr);
	($groupName, $groupType, $genericStr, $contents) = $$outref[0] =~ /^\s*(\S+):\s*([^,]+),\s*([^,]+),\s*(.*)$/;
	#print "<p>groupName=$groupName, groupType=$groupType, genericStr=$genericStr, contents=$contents</p>\n";
	if ($groupType =~ /static/i)     # create a static group
	  {
		$memberList = $contents;
		$genericChecked = ($genericStr =~ /not/i) ? 'checked' : '';
		$staticChecked = 'checked';
		$dynamicChecked = '';
	  }
	else          # dynamic group
	  {
		$selectString = $contents;
		$genericChecked = '';
		$staticChecked = '';
		$dynamicChecked = 'checked';
	  }
  }
else            # handle the case where we are returning from the trySelectButton or invoked from the action button on the main page
  {
	if (exists($::in{groupName})) { $groupName = $::in{groupName}; }
	if ($::in{groupType} eq 'dynamicType') { $dynamicChecked = 'checked'; }
	elsif ($::in{groupType} eq 'staticType') { $staticChecked = 'checked'; }
	if (exists($::in{selectString})) { $selectString = $::in{selectString}; }
	if (exists($::in{memberList})) { $memberList = $::in{memberList}; }
	elsif (exists($::in{nodes})) { $memberList = $::in{nodes}; }
  }
	
my $code = GuiUtils->processHTML('nodegrp-src.html');
eval $code;
if (length($@)) { print "<P>$@</P>"; }

&footer('', 'CSM Home');


